#include <tiny45.h>
#define EEPM1 5 
#define EEPM0 4 
#define EERE 0 
#define EEMPE 2
#define EEPE 1 

bit half;
unsigned char start[64];
unsigned char memory;
unsigned char Parity; 
unsigned char cursor,status; 
unsigned char ver[5];  
unsigned char i,j;
void EEPROM_write(unsigned int uiAddress, unsigned char ucData)
{
/* Wait for completion of previous write */
while(EECR & (1<<EEPE))
;
EECR=(0<<EEPM1)|(0<EEPM0);
/* Set up address and data registers */
EEARL = uiAddress;
EEDR = ucData;
/* Write logical one to EEMWE */
EECR |= (1<<EEMPE);
/* Start eeprom write by setting EEWE */
EECR |= (1<<EEPE);
}
unsigned char EEPROM_read(unsigned int uiAddress)
{
/* Wait for completion of previous write */
while(EECR & (1<<EEPE))
;
/* Set up address register */
EEARL = uiAddress;
/* Start eeprom read by writing EERE */
EECR |= (1<<EERE);
/* Return data from data register */
return EEDR;
}
// Timer 1 output compare A interrupt service routine
interrupt [TIM0_COMPA] void timer0_compa_isr(void)
{
while(PINB.2==half){}
half^=1;
PORTB.0=start[cursor]^(~half);
if(half) if(!cursor--) cursor=63;
}

void main(void)
{
PORTB=0x3E;
DDRB=0x01;

TCCR0A=0x02;
TCCR0B=0x07;
TCNT0=0x00;
OCR0A=0x20;
OCR0B=0x00;

GIMSK=0x00;
MCUCR=0x00;

TIMSK=0x10;

// Analog Comparator initialization
// Analog Comparator: Off
// Analog Comparator Input Capture by Timer/Counter 1: Off
ACSR=0x80;
ADCSRB=0x00;

//EEPROM_write(0,0x0F);
//EEPROM_write(1,0x00);
//EEPROM_write(2,0xE1);
//EEPROM_write(3,0x98);
//EEPROM_write(4,0x03);

for(cursor=63;cursor>54;cursor--)start[cursor]=1;
cursor=54;
for(i=0;i<5;i++){
 j = 8;  Parity=0; status=0;
 memory = EEPROM_read(i);               
  while(j--){
    if ( memory & 0x80 ){ start[cursor]=1; ver[status]++; Parity++; }
      else start[cursor]=0; 
  cursor--;
  status++;
    if(j==4||j==0){  start[cursor]=(Parity & 1);  Parity=0; cursor--; status=0;}
  memory<<= 1;
         }
}
start[4]=(ver[0]&1);
start[3]=(ver[1]&1);
start[2]=(ver[2]&1);
start[1]=(ver[3]&1);
start[0]=0;
cursor=63;
#asm("sei")

while (1)
      {
      // Place your code here

      };
}
